
;Child Window - DednDave, 10-2011

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        INCLUDE    ChildWin.inc
        .LIST

;###############################################################################################

        .DATA

szClassName     db 'ChildFrameClass',0
szChildClass    db 'ChildWinClass',0
szAppName       db 'Child Window',0

;------------------------------

        .DATA?

        ALIGN   4

hInstance       dd ?
hWin            dd ?
hChild          dd ?
dwScreenWidth   dd ?
dwScreenHeight  dd ?
dwFrameWidth    dd ?
dwFrameHeight   dd ?

cpt POINT <>
; x   dd ?
; y   dd ?

cwr             RECT <>
ccr             RECT <>
; left            dd ?
; top             dd ?
; right           dd ?
; bottom          dd ?

mws      MoveWin <>
; hWnd     HWND ?
; pt       POINT <>
;   x        dd ?
;   y        dd ?
; dwWidth  dd ?
; dwHeight dd ?

;###############################################################################################

        .CODE

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;------------------------------

        mov     ecx,uMsg
        cmp     ecx,WM_MOUSEMOVE
        jz      CmMove

        cmp     ecx,WM_SIZE
        jz      SizWin

        cmp     ecx,WM_CREATE
        jz      WndPrX

        cmp     ecx,WM_CLOSE
        jz      WndPrY

        cmp     ecx,WM_DESTROY
        jz      WndPrZ

;------------------------------

        pop     ebp
        JMP     DefWindowProc

;------------------------------------

;WM_MOUSEMOVE, mouse move, client area

CmMove: test byte ptr wParam,1
        jz      WndPr0

        call    MovWin

;------------------------------

WndPr0: xor     eax,eax
        ret

;------------------------------

;WM_SIZE

SizWin: INVOKE  GetClientRect,hWnd,offset cwr
        jmp     WndPr0

;------------------------------

;WM_CREATE

WndPrX: INVOKE  CreateWindowEx,NULL,offset szChildClass,offset szAppName,
                WS_CHILD or WS_THICKFRAME or WS_VISIBLE or WS_CLIPSIBLINGS,
                10,10,100,100,hWnd,IDC_CHILDWIN,hInstance,NULL
        mov     hChild,eax
        jmp     WndPr0

;------------------------------

;WM_CLOSE

WndPrY: INVOKE  DestroyWindow,hWnd
        jmp     WndPr0

;------------------------------

;WM_DESTROY

WndPrZ: INVOKE  PostQuitMessage,NULL
        jmp     WndPr0

;------------------------------

WndProc ENDP

;***********************************************************************************************

ChildProc PROC  hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;------------------------------

        mov     ecx,uMsg
        cmp     ecx,WM_MOUSEMOVE
        jz      CmMove

        cmp     ecx,WM_NCMOUSEMOVE
        jz      NmMove

        cmp     ecx,WM_LBUTTONDOWN
        jz      LftBtn

        cmp     ecx,WM_LBUTTONUP
        jz      LftBUp

        cmp     ecx,WM_CLOSE
        jz      ChldPY

        cmp     ecx,WM_DESTROY
        jz      ChldPZ

;------------------------------

DefPrc: pop     ebp
        JMP     DefWindowProc

;------------------------------------

;WM_MOUSEMOVE, mouse move, client area

CmMove: test byte ptr wParam,1
        jz      ChldP0

        call    MovWin

;------------------------------

ChldP0: xor     eax,eax
        ret

;------------------------------------

;WM_NCMOUSEMOVE, mouse move, non-client area

NmMove: test byte ptr wParam,1
        jz      DefPrc

        call    MovWin
        jmp     DefPrc

;------------------------------------

;WM_LBUTTONDOWN, left button down, client area

;translate the client coordinates in cwr to screen coordinates in ccr

LftBtn: mov     edx,offset ccr.right
        mov     eax,cwr.right
        mov     ecx,cwr.bottom
        mov     [edx].POINT.x,eax
        mov     [edx].POINT.y,ecx
        INVOKE  ClientToScreen,hWin,edx
        mov     edx,offset ccr.left
        xor     eax,eax
        mov     [edx].POINT.x,eax
        mov     [edx].POINT.y,eax
        INVOKE  ClientToScreen,hWin,edx

;fill a temporary RECT with child window screen coordinates

        mov     eax,hWnd
        sub     esp,sizeof RECT
        mov     mws.hWnd,eax
        INVOKE  GetWindowRect,eax,esp

;translate the upper left window coordinates to main window client coordinates

        push    [esp].POINT.y
        push    [esp+4].POINT.x
        INVOKE  ScreenToClient,hWin,esp

;get the current cursor position in main window client coordinates

        push    ecx
        push    eax
        INVOKE  GetCursorPos,esp
        INVOKE  ScreenToClient,hWin,esp
        pop     edx
        pop     ecx

;store the upper left corner coordinates, less the current cursor coordinates (for mouse move)

        pop     eax
        sub     eax,edx
        mov     edx,offset mws
        mov     [edx].MoveWin.pt.x,eax
        pop     eax
        sub     eax,ecx
        mov     [edx].MoveWin.pt.y,eax

;store the width and height of the child window (for mouse move)

        mov     ecx,[esp].RECT.right
        mov     eax,[esp].RECT.bottom
        sub     ecx,[esp].RECT.left
        sub     eax,[esp].RECT.top
        mov     [edx].MoveWin.dwWidth,ecx
        mov     [edx].MoveWin.dwHeight,eax

;fill a temporary POINT structure with cursor screen coordinates

        sub     esp,sizeof POINT
        INVOKE  GetCursorPos,esp

;adjust the ccr rectangle for clipping

        pop     eax                        ;EAX = cursor X position
        mov     edx,[esp+4].RECT.right
        dec     edx
        sub     edx,eax
        sub     eax,[esp+4].RECT.left
        sub     ccr.right,edx
        add     ccr.left,eax

        pop     eax                        ;EAX = cursor Y position
        mov     edx,[esp].RECT.bottom
        dec     edx
        sub     edx,eax
        sub     eax,[esp].RECT.top
        sub     ccr.bottom,edx
        add     ccr.top,eax

;discard the temporary RECT

        add     esp,sizeof RECT

;set the clip rectangle

        INVOKE  ClipCursor,offset ccr
        jmp     ChldP0

;------------------------------------

;WM_LBUTTONUP, left button up, client area

LftBUp: xor     eax,eax
        mov     mws.hWnd,eax
        INVOKE  ClipCursor,eax
        jmp     ChldP0

;------------------------------

;WM_CLOSE

ChldPY: INVOKE  DestroyWindow,hWnd
        jmp     ChldP0

;------------------------------

;WM_DESTROY

ChldPZ: INVOKE  PostQuitMessage,NULL
        jmp     ChldP0

;------------------------------

ChildProc ENDP

;***********************************************************************************************

MovWin  PROC

        cmp dword ptr mws.hWnd,0
        jz      MvWin1

        push    ecx
        push    eax
        INVOKE  GetCursorPos,esp
        INVOKE  ScreenToClient,hWin,esp
        pop     eax
        pop     ecx
        cmp     eax,cpt.x
        jnz     MvWin0

        cmp     ecx,cpt.y
        jz      MvWin1

MvWin0: mov     edx,offset mws
        add     ecx,[edx].MoveWin.pt.y
        add     eax,[edx].MoveWin.pt.x
        INVOKE  MoveWindow,[edx].MoveWin.hWnd,eax,ecx,[edx].MoveWin.dwWidth,[edx].MoveWin.dwHeight,TRUE

MvWin1: ret

MovWin  ENDP

;***********************************************************************************************

RegTwo  PROC

;Call With: EDI = 0
;           EBP = hInstanceEDI = 0
;
;  Returns: EBX = hIcon
;           ESI = offset szClassName
;           EDI = 0
;           EBP = hInstance

        INVOKE  LoadIcon,ebp,IDI_ICON
        xchg    eax,ebx                                 ;EBX = hIcon
        INVOKE  LoadCursor,edi,IDC_ARROW                ;EAX = hCursor
        mov     esi,offset szChildClass                 ;ESI = offset szClassName
        push    eax
        mov     edx,ChildProc                           ;EDX = lpfnWndProc
        mov     ecx,COLOR_BTNFACE+1                     ;ECX = hbrBackground
        call    RegOne
        mov     esi,offset szClassName                  ;ESI = offset szClassName
        pop     eax
        mov     edx,WndProc                             ;EDX = lpfnWndProc
        mov     ecx,COLOR_SCROLLBAR+1                   ;ECX = hbrBackground

RegOne: push    ebx                                     ;WNDCLASSEX.hIconSm
        push    esi                                     ;WNDCLASSEX.lpszClassName
        push    edi                                     ;WNDCLASSEX.lpszMenuName
        push    ecx                                     ;WNDCLASSEX.hbrBackground
        push    eax                                     ;WNDCLASSEX.hCursor
        push    ebx                                     ;WNDCLASSEX.hIcon
        push    ebp                                     ;WNDCLASSEX.hInstance
        push    edi                                     ;WNDCLASSEX.cbWndExtra
        push    edi                                     ;WNDCLASSEX.cbClsExtra
        push    edx                                     ;WNDCLASSEX.lpfnWndProc
        push    edi                                     ;WNDCLASSEX.style
        push    sizeof WNDCLASSEX                       ;WNDCLASSEX.cbSize
        INVOKE  RegisterClassEx,esp
        add     esp,sizeof WNDCLASSEX
        ret

RegTwo  ENDP

;***********************************************************************************************

_main   PROC

;------------------------------

;initialize common controls

        xor     edi,edi                                 ;EDI = 0
        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp

;------------------------------

;initialize system metrics

        INVOKE  GetSystemMetrics,SM_CXSCREEN
        mov     dwScreenWidth,eax
        INVOKE  GetSystemMetrics,SM_CYSCREEN
        mov     dwScreenHeight,eax
        INVOKE  GetSystemMetrics,SM_CXSIZEFRAME
        mov     dwFrameWidth,eax
        INVOKE  GetSystemMetrics,SM_CYSIZEFRAME
        mov     dwFrameHeight,eax

;------------------------------

;register the window classes

        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        xchg    eax,ebp                                 ;EBP = hInstance
        call    RegTwo

;------------------------------

;create the window

        INVOKE  CreateWindowEx,edi,esi,offset szAppName,
                WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN,
                CW_USEDEFAULT,SW_SHOWNORMAL,400,300,edi,edi,ebp,edi
        mov     hWin,eax
        INVOKE  UpdateWindow,eax

;------------------------------

;message loop

        pushad                                          ;create stack space for MSG struct
        mov     ebp,esp                                 ;EBP = offset MSG
        jmp short mLoop1

mLoop0: INVOKE  TranslateMessage,ebp
        INVOKE  DispatchMessage,ebp

mLoop1: INVOKE  GetMessage,ebp,edi,edi,edi
        inc     eax                                     ;exit only
        shr     eax,1                                   ;if 0 or -1
        jnz     mLoop0                                  ;otherwise, we loop

;------------------------------

;exit program

        pop     eax                                     ;MSG.wParam is the parm for ExitProcess
        JMP     ExitProcess

_main   ENDP

;###############################################################################################

        END     _main

